/***************************************************************************
                          peer.h  -  description
                             -------------------
    begin                : Fri Nov 2 2001
    copyright            : (C) 2001 by Constantinos A. Kotsokalis
    email                : ckotso@netmode.ntua.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_H
#define CLIENT_H

/**This class represents the thread that handles requests
from other detectors in order to pass queries to neighbour
peers, thus trace attacks back to their originating point.

  *@author Constantinos A. Kotsokalis
  */

class Client;

// Common C++ headers
#include <cc++/socket.h>
#include <cc++/thread.h>
#include <cc++/misc.h>

#ifdef  CCXX_NAMESPACES
using namespace std;
using namespace ost;
#endif

// Custom project headers
#include "common.h"
#include "peerconnect.h"

// Standard C headers
#include <stdio.h>

// Standard C++ Library templates)
#include <string>
#include <map>
#include <vector>

// This class is derived from TCPSession (available through CommonC++).
// It handles connections from remote detectors.
class Client : public TCPSession {
private:
	// The detector that provided us with data, if any
	InetHostAddress prevdetector;
	Collector *cl;
	// Returns the logical interface for the detector that provided us with attack info
	uint16_t getOutput();

	virtual void Final();

public:
	// Class constructor
	Client(TCPSocket&, InetHostAddress, Collector *);
	virtual ~Client();
	virtual void Run();
};


#endif
