/***************************************************************************
                                 detector.h
                             -------------------
    begin                : Mon Feb 4 2002
    copyright            : (C) 2002 by Constantinos A. Kotsokalis
    email                : ckotso@grnet.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DETECTOR_H
#define DETECTOR_H

#include <cc++/thread.h>

/**Detector is the thread that analyzes collected data
and looks for attacks.
  *@author Constantinos A. Kotsokalis
  */

class Detector;

#include "collector.h"
#include "timeslot.h"
#include "timestamp.h"
#include "ifpair.h"
#include "peerconnect.h"

#include <string>
#include <map>

class Detector : public Thread  {
public: 
	Detector(TimeSlot *, Collector *, float&, float&, string, string, Mutex *);
	virtual ~Detector();
	virtual void Run();

private:
	TimeSlot *procts;
	Mutex *mtx;
	float increase, percentage;
	Collector *cl;
	string owner, cmd;

	virtual void Final();
	void LogAttackStart(uint16_t, uint16_t, InetHostAddress, InetHostAddress, uint32_t, uint32_t);
	void LogAttackStop(uint16_t, uint16_t, InetHostAddress, uint32_t, uint32_t);
};

#endif
