/***************************************************************************
                                 mconfig.cpp
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Constantinos A. Kotsokalis
    email                : ckotso@grnet.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mconfig.h"

MConfig::MConfig(const char *config){
	// Open the config file
	ifstream conf(config);
	if (!conf.is_open()){
		perror(config);
		exit(errno);
	}
	
	Stripper stripper;

	string line;
	while (getline(conf, line)){
		// Strip white spaces from the beginning and the end of
		// the line -- the Strip() method is defined below
		line = stripper.Strip(line);
		// If the line is a comment continue
		if (line.empty() || line[0] == '#')
			continue;

		const char *str = line.c_str();

		StringTokenizer tok(str);
		StringTokenizer::iterator it = tok.begin();

		string key = string(*it);
		vector<string> val;
		for (++it; it != tok.end(); ++it)
			val.push_back(*it);

		// Insert the key/value pair to the hash table
		configmap[key] = val;
	}

	// ...and close the configuration file
	conf.close();
}

MConfig::~MConfig(){

}


/** Read property of map< string, vector<string> > configmap. */
const map< string, vector<string> >& MConfig::getconfigmap(){
	return configmap;
}
