/***************************************************************************
                                 pdu.cpp
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Constantinos A. Kotsokalis
    email                : ckotso@grnet.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pdu.h"

PDU::PDU(){
}

PDU::~PDU(){
}

void PDU::dpSet(uint16_t& v, uint16_t& n, uint32_t& curtime, uint32_t& sec, uint32_t& msec, uint8_t *buff, uint8_t aggtype=0){
	version = v;
	numflows = n;
	usec = sec;
	umsec = msec;
	sysuptime = curtime;
	
	int size = 0;
	// Set the size based on the version of the datagram
	switch (version){
		case NETFLOW_V1:
				size = V1_BODY_LEN;
				break;
		case NETFLOW_V5:
				size = V5_BODY_LEN;
				break;
		case NETFLOW_V8:
				if (AS_ISSET(aggtype))
					size = V8AS_BODY_LEN;
				else if (PP_ISSET(aggtype))
					size = V8PP_BODY_LEN;
				else if (SP_ISSET(aggtype))
					size = V8SP_BODY_LEN;
				else if (DP_ISSET(aggtype))
					size = V8DP_BODY_LEN;
				else if (PR_ISSET(aggtype))
					size = V8PR_BODY_LEN;
				break;
	}

	if (!size)
		return;

	// Set each flow's data	
	for (int i=0; i<numflows; i++){
		memcpy((void *)flowbody, (void *)(buff+i*size), size);
		flows[i].flSet(version, sysuptime, usec, umsec, flowbody, aggtype);
	}
}

void PDU::addFlows(TimeSlot *tsl){
	for (int i=0; i<numflows; i++)
		tsl->Add(flows[i]);
}

