/***************************************************************************
                          peer.h  -  description
                             -------------------
    begin                : Fri Nov 2 2001
    copyright            : (C) 2001 by Constantinos A. Kotsokalis
    email                : ckotso@netmode.ntua.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PEER_H
#define PEER_H

/**This class represents the thread that handles requests
from other detectors in order to pass queries to neighbour
peers, thus trace attacks back to their originating point.

  *@author Constantinos A. Kotsokalis
  */

class Peer;

// Common C++ headers
#include <cc++/socket.h>
#include <cc++/thread.h>
#include <cc++/misc.h>

#ifdef  CCXX_NAMESPACES
using namespace std;
using namespace ost;
#endif

// Custom project headers
#include "common.h"
#include "peerconnect.h"
#include "client.h"

// Standard C headers
#include <stdio.h>

// Standard C++ Library templates)
#include <string>
#include <map>
#include <vector>

// The Peer class is the part of the software that listens for connections
// from other (neighbor) detectors. It is executed in a separate thread.
class Peer : public Thread  {
private:
	// Which port to bind to
	uint16_t port;
	Collector *cl;
	virtual void Final();

public: 
	// Class constructor
	Peer(uint16_t, Collector *);
	// Class destructors
	virtual ~Peer();
	virtual void Run();
};

#endif
