/***************************************************************************
                          peerconnect.cpp  -  description
                             -------------------
    begin                : Fri Nov 23 2001
    copyright            : (C) 2001 by Constantinos A. Kotsokalis
    email                : ckotso@netmode.ntua.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "peerconnect.h"

// Initialize the class that connects to a remote detector
PeerConnect::PeerConnect(RemoteDetector rmd, InetHostAddress lattacked, int lmode, char *lowner) : TCPSession(rmd.remote, rmd.remport){
	mode = lmode;
	attacked = lattacked;
	owner = lowner;
}

PeerConnect::~PeerConnect(){

}

// The class executes in a seperate thread. This method starts the new thread.
void PeerConnect::Run(){
	// Wait until connection is established
	WaitConnection();
	// Right info on the opened socket and exit from the thread
	*tcp() << attacked << " " << mode << " " << owner << endl;
	Exit();
}

void PeerConnect::Final(){
	delete this;
}

