/***************************************************************************
                          peerconnect.h  -  description
                             -------------------
    begin                : Fri Nov 23 2001
    copyright            : (C) 2001 by Constantinos A. Kotsokalis
    email                : ckotso@netmode.ntua.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PEERCONNECT_H
#define PEERCONNECT_H

/**This is the thread that connects to remote detectors and
forwards information about ongoing attacks.
  *@author Constantinos A. Kotsokalis
  */

class PeerConnect;

#include <cc++/thread.h>
#include <cc++/socket.h>

#ifdef  CCXX_NAMESPACES
using namespace std;
using namespace ost;
#endif

typedef struct RemoteDetector;

#include "collector.h"

// PeerConnect is executed in a separate thread
class PeerConnect : public TCPSession  {
private:
	// The mode shows if it's a flow-based or a packet-based attack
	int mode;
	// The victim address
	InetHostAddress attacked;
	// The email address of the victim's owner
	char *owner;
	virtual void Final();

public:
	// The only public method available, connects and forwards data to the peer
	PeerConnect(RemoteDetector, InetHostAddress, int, char *);
	virtual ~PeerConnect();
	virtual void Run();
};

#endif
