#!/usr/bin/env python

SNMPWALK = "/usr/bin/snmpwalk"

import os, string, sys

if (len(sys.argv) < 3):
	print "usage: " + sys.argv[0] + " <router> <interface_file>"
	sys.exit(0)

ipdict = {}

ifIPInt = os.popen(SNMPWALK + " " + sys.argv[1] + " public ip.ipAddrTable.ipAddrEntry.ipAdEntIfIndex", "r")
lines = ifIPInt.readlines()
ifIPInt.close()

for line in lines:
	tokens = string.split(line);
	interface = tokens[2]
	ip = string.split(tokens[0], "ip.ipAddrTable.ipAddrEntry.ipAdEntIfIndex.")[1]
	ipdict[interface] = [ip]

ifSpeed = os.popen(SNMPWALK + " " + sys.argv[1] + " public interfaces.ifTable.ifEntry.ifSpeed", "r")
speedlines = ifSpeed.readlines()
ifSpeed.close()

for line in speedlines:
	tokens = string.split(line)
	interface = string.split(tokens[0], '.')[4]
	bandwidth = (int)(string.atol(tokens[3])/8)
	if interface in ipdict.keys():
		ipdict[interface].append(bandwidth);

fp = open(sys.argv[2], "w")
for interface in ipdict.keys():
	ip, bandwidth = ipdict[interface]
	fp.write("%s %s\n" % (interface, ip))
fp.close()


