/***************************************************************************
                                 timestamp.cpp
                             -------------------
    begin                : Sat Feb 2 2002
    copyright            : (C) 2002 by Constantinos A. Kotsokalis
    email                : ckotso@grnet.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "timestamp.h"

TimeStamp::TimeStamp(){
	seconds = milliseconds = 0;
}

TimeStamp::TimeStamp(uint32_t& sec, uint32_t& milli){
	seconds = sec;
	milliseconds = milli;
}

TimeStamp::~TimeStamp(){

}

/** operator <  */
bool TimeStamp::operator < (const TimeStamp& ts){
	if ((seconds < ts.seconds) || ((seconds == ts.seconds) && (milliseconds < ts.milliseconds)))
		return true;
	else
		return false;
}

/** operator <=  */
bool TimeStamp::operator <= (const TimeStamp& ts){
	if ((seconds < ts.seconds) || ((seconds == ts.seconds) && (milliseconds <= ts.milliseconds)))
		return true;
	else
		return false;
}

/** operator >  */
bool TimeStamp::operator > (const TimeStamp& ts){
	if ((seconds > ts.seconds) || ((seconds == ts.seconds) && (milliseconds > ts.milliseconds)))
		return true;
	else
		return false;
}

/** operator >=  */
bool TimeStamp::operator >= (const TimeStamp& ts){
	if ((seconds > ts.seconds) || ((seconds == ts.seconds) && (milliseconds >= ts.milliseconds)))
		return true;
	else
		return false;
}

/** operator +  */
TimeStamp TimeStamp::operator + (const TimeStamp& ts){
	TimeStamp nts;

	nts.seconds = seconds + ts.seconds;
	nts.milliseconds = milliseconds + ts.milliseconds;
	if (nts.milliseconds >= 1000){
		nts.milliseconds -= 1000;
		nts.seconds++;
	}

	return nts;
}

/** operator -  */
TimeStamp TimeStamp::operator - (const TimeStamp& ts){
	TimeStamp nts;

	if (seconds > ts.seconds){
		nts.seconds = seconds - ts.seconds;
		if (milliseconds < ts.milliseconds){
			nts.milliseconds = 1000 - (ts.milliseconds - milliseconds);
			nts.seconds--;
		}
		else
			nts.milliseconds = milliseconds - ts.milliseconds;
		
		return nts;
	}
	else if ((seconds == ts.seconds) && (milliseconds >= ts.milliseconds)){
		nts.seconds = 0;
		nts.milliseconds = milliseconds - ts.milliseconds;

		return nts;
	}
	else {
		uint32_t sec = 0;
		uint32_t msec = 0;
		return TimeStamp(sec, msec);
	}
}

/** operator =  */
TimeStamp& TimeStamp::operator = (const TimeStamp& ts){
	seconds = ts.seconds;
	milliseconds = ts.milliseconds;
	
	return *this;
}
