/***************************************************************************
                                 timestamp.h
                             -------------------
    begin                : Sat Feb 2 2002
    copyright            : (C) 2002 by Constantinos A. Kotsokalis
    email                : ckotso@grnet.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TIMESTAMP_H
#define TIMESTAMP_H


/**Used for time manipulation
  *@author Constantinos A. Kotsokalis
  */

class TimeStamp;

#include "common.h"

class TimeStamp {
public: 
	TimeStamp();
	TimeStamp(uint32_t&, uint32_t&);
	~TimeStamp();
  /** operator >=  */
  bool operator >= (const TimeStamp& );
  /** operator >  */
  bool operator > (const TimeStamp& );
  /** operator <=  */
  bool operator <= (const TimeStamp& );
  /** operator <  */
  bool operator < (const TimeStamp& );
  /** operator -  */
  TimeStamp operator - (const TimeStamp& );
  /** operator +  */
  TimeStamp operator + (const TimeStamp& );
  /** operator =  */
  TimeStamp& operator = (const TimeStamp& );
	uint32_t& getSec() { return seconds; }
	uint32_t& getMsec() { return milliseconds; }

private:
	uint32_t seconds, milliseconds;
};

#endif
