/***************************************************************************
                                 webbroker.h
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Constantinos A. Kotsokalis
    email                : ckotso@grnet.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef WEBBROKER_H
#define WEBBROKER_H

/**Accepts connections from the CGI script that
provides traffic information
  *@author Constantinos A. Kotsokalis
  */

class WebBroker;

#include <cc++/socket.h>
#include <cc++/thread.h>

#ifdef  CCXX_NAMESPACES
	using namespace std;
	using namespace ost;
#endif

#include "collector.h"
#include "timeslot.h"
#include "timestamp.h"
#include "ifpair.h"
#include "stripper.h"

#include <string>
#include <map>

class webTCPSocket : public TCPSocket {
protected:
	bool OnAccept(const InetHostAddress &ia, tpport_t port);

public:
	InetHostAddress websrv;
	webTCPSocket(InetAddress &ia, uint16_t port) : TCPSocket(ia, port) {};
};

class WebBroker : public Thread  {
public: 
	WebBroker(uint16_t&, InetHostAddress&, Mutex *, Collector *);
	virtual ~WebBroker();
	virtual void Run();

private:
	Collector *collector;
	Mutex *mtx;
	uint16_t port;
	InetHostAddress websrv;
	virtual vector<string> ProcessRequest(string);
	virtual vector<string> retInterfaces();
	virtual vector<string> retData(vector<string>);
	virtual vector<string> retAttacks(vector<string>);
};

#endif
